/*global $, console*/
var current = 0,
    loop,
    runningLoop = null,
    image = '.image',
    fade = 300,
    loopDelay = 2000,
    imageMaxCount = 4;


//Skip to selected image.
function slideshow_skip(num, forced) {
    "use strict";
    
    //Check if our skip was forced
    if (forced === true) {
        clearInterval(runningLoop);
        runningLoop = null;
    }

    //Check if a new image is being displayed
    if (current !== num) {

        var child = ".selectors li:nth-child(";

        //Fade image out and switch to selected image
        $(image).fadeOut(fade, function () {

            //Set new background
            $(image).css("background", "url(./assets/slideshow-" + num + ".jpg)");
        });

        //Check for a valid slide
        if (current >= 1) {
            $(child + current + ")").removeClass("selected");
        }
        
        //Update our current slide
        current = num;
        
        //Fade the image in and create a delay
        $(image).fadeIn(fade);
        
        //Check for a valid slide
        if (current >= 1) {
            $(child + current + ")").addClass("selected");
        }
    }
    
    //Check if skip was forced
    if (forced === true) {
        runningLoop = setInterval(loop, loopDelay);
    }
}

//Increments through the slides
function loop() {
    "use strict";
    
    //Increment our current slide by one
    var increment = (current + 1);
    
    //Check if our slide is out of index
    // and reset if it is.
    if (increment > imageMaxCount) {
        increment = 1;
    }
    
    //Skip to our next slide.
    slideshow_skip(increment, false);
}

//Wait for our document to load, and execute.
$(document).ready(function () {
    "use strict";
    
    //load default starting image
    slideshow_skip(1, false);
    
    runningLoop = setInterval(loop, loopDelay);
});